package org.test;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import javax.servlet.annotation.WebServlet;

import com.vaadin.annotations.Push;
import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.server.ExternalResource;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.ui.Button;
import com.vaadin.ui.Grid;
import com.vaadin.ui.Label;
import com.vaadin.ui.Link;
import com.vaadin.ui.PopupView;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;

/**
 * This UI is the application entry point. A UI may either represent a browser window
 * (or tab) or some part of an HTML page where a Vaadin application is embedded.
 * <p>
 * The UI is initialized using {@link #init(VaadinRequest)}. This method is intended to be
 * overridden to add component to the user interface and initialize non-component functionality.
 */
@Theme("mytheme")
@Push
public class MyUI extends UI {

	Random r = new Random();
	Label l = new Label();
	private Grid<Device> g;

    @Override
    protected void init(VaadinRequest vaadinRequest) {
		final VerticalLayout lo = new VerticalLayout();
		setContent(lo);
		g = new Grid<Device>();
		lo.addComponent(g);
		g.addComponentColumn(d -> {
			if(d.panels.size() == 1) {
				return new Link(d.panels.get(0), new ExternalResource("/foo/" + d.panels.get(0)));
			} else if(d.panels.size() > 1) {
				VerticalLayout vl = new VerticalLayout();
				for(String dp:d.panels) {
					vl.addComponent(new Link(dp, new ExternalResource("/foo/" + dp)));
				}
				return new PopupView(d.panels.size() + " pieces", vl);
			} else {
				return new Label("none");
			}

		}).setId("adsasdf").setCaption("foobar").setSortProperty("baz");
		ArrayList<Device> devices = new ArrayList<>(1000);
		for(int i = 0; i < 1000; i++) {
			devices.add(new Device());
		}
		g.setItems(devices);
		lo.addComponent(new Button("remove grid", e -> lo.removeComponent(g)));
	}


	public class Device {
		String name;
		List<String> panels;

		public Device() {
			name = "device" + r.nextInt(10000);
			panels = getList(3);
		}
	}


	private List<String> getList(int max) {
		int n = r.nextInt(max);
		ArrayList<String> li = new ArrayList<String>(n);
		for(int i = 0; i < n; i++) {
			li.add("foo" + r.nextInt(100));
		}
		return li;
	}

	@WebServlet(urlPatterns = "/*", name = "MyUIServlet", asyncSupported = true)
	@VaadinServletConfiguration(ui = MyUI.class, productionMode = false)
	public static class MyUIServlet extends VaadinServlet {
	}

    }
